<template>
  <v-container>
    <v-form v-show="!code.show" v-model="valid" @submit.prevent="onSubmit">
      <v-row v-if="authType === 'register'">
        <v-col cols="12" md="6">
          <v-text-field
            id="first-name"
            v-model="first_name"
            :label="$t('name')"
            :rules="rules"
            prepend-icon="mdi-account"
            required
          ></v-text-field>
        </v-col>
        <v-col cols="12" md="6">
          <v-text-field
            id="last-name"
            v-model="last_name"
            :label="$t('lastname')"
            :rules="rules"
            required
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12">
          <client-only>
            <vue-tel-input
              v-model="phone"
              :rules="rules"
              name="userPhone"
              :placeholder="$t('phonenumber')"
              required
              :valid-characters-only="true"
              mode="international"
              prepend-icon="mdi-phone"
              @validate="phoneIsValid"
            ></vue-tel-input>
          </client-only>
        </v-col>
      </v-row>
      <v-row justify="center" class="my-5">
        <div :id="captcha" class="recaptcha"></div>
      </v-row>
      <v-row>
        <v-col cols="12">
          <v-btn id="save-user" :disabled="!valid" block type="submit">
            {{ $t('send') }}
          </v-btn>
        </v-col>
      </v-row>
    </v-form>
    <form v-show="code.show" @submit.prevent="onCode">
      <v-row>
        <v-col cols="12">
          <br />
          <p class="text-xs-center">
            {{ $t('smscode') }}
          </p>
          <v-text-field
            v-model="code.id"
            :label="$t('verificationcode')"
            prepend-icon="mdi-account-key"
            required
          ></v-text-field>
        </v-col>
        <v-col cols="12">
          <v-btn :disabled="!code.id" block color="primary" type="submit">
            {{ authType === 'login' ? $t('login') : $t('register') }}
          </v-btn>
        </v-col>
      </v-row>
    </form>
    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </v-container>
</template>

<script lang="ts">
import _ from 'lodash'
import axios from 'axios'

import Vue from 'vue'

import { setUserDoc } from '~/services/User'
import { signInData } from '~/services/Firebase'

declare global {
  interface Window {
    recaptchaVerifierRegisterSms: any
    recaptchaWidgetRegisterSmsId: any
  }
}

export default Vue.extend({
  name: 'CelularRegister',
  components: {},
  props: {
    captcha: {
      type: String,
      default: 'recaptcha-register-sms',
    },
    authType: {
      type: String,
      default: 'register',
    },
  },
  data() {
    return {
      valid: false,
      phoneValidation: false,
      first_name: null,
      last_name: null,
      phone: null,
      rules: [(v: any) => !!v || 'Campo requerido'],
      snackbar: {
        show: false,
        color: '',
        mode: '',
        timeout: 6000,
        text: '',
        right: '',
        top: '',
      },
      code: {
        id: '',
        show: false,
        verificationId: '',
      },
      reCAPTCHARegisterSMS: false,
      loading: false,
      urlEndpoints: process.env.OSCITY_ENDPOINTS_URL,
    }
  },
  mounted() {
    const self = this
    window.recaptchaVerifierRegisterSms = new this.$fireModule.auth.RecaptchaVerifier(
      this.captcha,
      {
        callback() {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          return new Promise<string | void>((resolve, reject) => {
            self.reCAPTCHARegisterSMS = true
            resolve()
          })
        },
        'expired-callback'() {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          return new Promise<string | void>((resolve, reject) => {
            self.reCAPTCHARegisterSMS = false
          })
        },
        size: self.$vuetify.breakpoint.smAndDown ? 'compact' : 'normal',
      }
    )
    window.recaptchaVerifierRegisterSms.render().then((widgetId: any) => {
      window.recaptchaWidgetRegisterSmsId = widgetId
    })
  },
  methods: {
    async onSubmit(): Promise<void> {
      try {
        this.loading = true
        this.reCAPTCHARegisterSMS = false
        const res = await axios.post(`${this.urlEndpoints}/userPhoneExist`, {
          phone: this.phone,
        })
        if (this.authType === 'register') {
          if (_.isEmpty(res.data.user)) {
            const code = await this.$store.dispatch('users/sendCode', {
              phone: this.phone,
              verifier: window.recaptchaVerifierRegisterSms,
            })
            this.code.verificationId = code.verificationId
            this.code.show = true
            this.snackbar.show = true
            this.snackbar.color = 'success'
            this.snackbar.text = 'Código de verificación enviado con éxito.'
            this.code.show = true
          } else {
            this.snackbar.show = true
            this.snackbar.text =
              'Este número ya ha sido registrado, por favor inicia sesión.'
            this.snackbar.color = 'error'
          }
        } else if (this.authType === 'login' && res.data.user) {
          const code = await this.$store.dispatch('users/sendCode', {
            phone: this.phone,
            verifier: window.recaptchaVerifierRegisterSms,
          })
          this.code.verificationId = code.verificationId
          this.code.show = true
          this.snackbar.show = true
          this.snackbar.color = 'success'
          this.snackbar.text = 'Código de verificación enviado con éxito.'
          this.code.show = true
        } else {
          this.snackbar.show = true
          this.snackbar.text = 'Número desconocido o no registrado'
          this.snackbar.color = 'error'
        }
        this.loading = false
      } catch (error) {
        this.snackbar.show = true
        this.snackbar.text = error
        this.snackbar.color = 'error'
      }
    },
    phoneIsValid($event: any): void {
      this.phoneValidation = $event.isValid
    },
    async onCode(): Promise<void> {
      try {
        const credential = await this.$fireModule.auth.PhoneAuthProvider.credential(
          this.code.verificationId,
          this.code.id
        )
        const { user } = await signInData(this.$fire, { credential })
        // Create user collection
        if (this.authType === 'register') {
          await setUserDoc(this.$fire, user.uid, {
            phone: this.phone,
            first_name: this.first_name,
            last_name: this.last_name,
            activated: true,
          })
        }
        // Set user in store
        this.loading = false
        this.code = {
          id: '',
          show: false,
          verificationId: '',
        }
        this.$emit('change', false)
      } catch (error) {
        this.loading = false
        this.snackbar.show = true
        this.snackbar.text =
          error.message ||
          'El código de verificación es incorrecto o ha caducado.'
        this.snackbar.color = 'error'
      }
    },
  },
})
</script>
